﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using System.Linq;

using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel.DataAnnotations;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.Models;
using Newtonsoft.Json;
using Syncfusion.Linq;
using Syncfusion.JavaScript.DataSources;
using Microsoft.AspNetCore.Http;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using Newtonsoft.Json.Linq;
using WebApplication8;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {
        public static List<OrderDetails> order = new List<OrderDetails>();
        public IActionResult Index()
        {
            if (order.Count() == 0)
                BindDataSource();
            ViewBag.datasource = order;
            return View();
        }
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new OrderDetails(code + 1, "ALFKI", i + 0, 2.3 * i, "Berlin"));
                order.Add(new OrderDetails(code + 2, "ANATR", i + 2, 3.3 * i, "Madrid"));
                order.Add(new OrderDetails(code + 3, "ANTON", i + 1, 4.3 * i, "Cholchester"));
                order.Add(new OrderDetails(code + 4, "BLONP", i + 3, 5.3 * i, "Marseille"));
                order.Add(new OrderDetails(code + 5, "BOLID", i + 4, 6.3 * i, "Tsawassen"));
                code += 5;
            }
        }
        public ActionResult NormalUpdate([FromBody]CRUDModel<OrderDetails> myObject)
        {
            var ord = myObject.Value;
            OrderDetails val = order.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
            val.OrderID = ord.OrderID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.Freight = ord.Freight;
            val.ShipCity = ord.ShipCity;
            return Json(myObject.Value);
        }
        public ActionResult NormalInsert([FromBody]CRUDModel<OrderDetails> value)
        {
            order.Insert(order.Count, value.Value);
            return Json(order);
        }
        public ActionResult NormalDelete([FromBody]CRUDModel<OrderDetails> value)
        {
            order.Remove(order.Where(or => or.OrderID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }
        public class OrderDetails
        {
            public OrderDetails()
            {

            }
            public OrderDetails(int OrderID, string CustomerId, int EmployeeId, double Freight, string ShipCity)
            {
                this.OrderID = OrderID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.ShipCity = ShipCity;
            }

            public int? OrderID { get; set; }
            public string CustomerID { get; set; }
            public int? EmployeeID { get; set; }
            public double? Freight { get; set; }
            public string ShipCity { get; set; }
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
